﻿using System;
using System.Linq;
using System.Windows.Forms;
using Irony.Parsing;

namespace Benchmark_Generator {
  public partial class BenchmarkGeneratorView : Form {
    private readonly ExpressionGrammar grammar;

    public BenchmarkGeneratorView() {
      InitializeComponent();
      grammar = new ExpressionGrammar();
    }

    private void button2_Click(object sender, EventArgs e) {
      var language = new LanguageData(grammar);
      var parser = new Parser(language);
      try {
        var sample = richTextBox1.Text;
        string output = string.Empty;
        parser.Parse(sample);
        var tree = parser.Context.CurrentParseTree;
        if (tree.Status == ParseTreeStatus.Error) {
          // if there's a parse error then the root of the tree will be null
          output = tree.ParserMessages.Aggregate(output, (current, m) => current + m.Message);
        } else {
          //          output = grammar.RunSample(new RunSampleArgs(language, sample, tree));
          output = "Parsing successful.";
        }
        richTextBox2.Text = output;
      }
      catch (Exception ex) {
        richTextBox2.Text = ex.Message;
      }
    }
  }
}
